#!/usr/bin/perl -w

use strict;
my %sl     = ();
my $count  = 0;
my $bigger = 0;
my $equal  = 0;

die "Usage: $0 SLFILE\n" unless @ARGV >= 1;

while (<>) {
	chomp;
	my @f = split /:/;
	my @g = @f[ 0, 1, 2, 3, 5, 6, 7 ];
	my ( $seq, $strand, $offset, $mfe, $left, $right, $loop ) = @g;

	next if $mfe > -20;     # not stable enough
	next if $left < 16;     # not long enough
	next if $right < 16;    # not long enough

	my $beginloop = $offset + $left - 1;
	my $endloop   = $offset + $left + $loop - 1;
	my $looploc   = qq($beginloop:$endloop);
	if ( exists $sl{$seq}{$strand}{$looploc} ) {
		my @h = @{ $sl{$seq}{$strand}{$looploc} };
		if ( $left > $h[5] or $right > $h[6] ) {
			$sl{$seq}{$strand}{$looploc} = \@f;
			$bigger++;
		}
		$equal++ if $left == $h[5] and $right == $h[6];
	}
	else {
		$sl{$seq}{$strand}{$looploc} = \@f;
		$count++;
	}
}

print STDERR "COUNT=$count BIGGER=$bigger EQUAL=$equal\n";

foreach my $seq ( keys %sl ) {
	foreach my $strand ( keys %{ $sl{$seq} } ) {
		foreach my $ll ( keys %{ $sl{$seq}{$strand} } ) {
			print join( ":", @{ $sl{$seq}{$strand}{$ll} } ) . "\n";
		}
	}
}

