/*

 Command-Line Option Parsing Header File

 by Nuno D. Mendes
 $Id: clo.h,v 1.1 2008/10/02 16:32:52 rnl14480 Exp $

 */

#ifndef CLO_H
#define CLO_H

#include "types.h"

#define CLO_TOOFEW -10
#define CLO_MISSINGPARAM -20
#define CLO_BADFORMAT	-30

#define CLO_UNKNOWN_OPTION -100

struct clo_str {
	char short_option;
	char *long_option;
	char *description;
	boolean_t has_param;
	boolean_t last_option;
	boolean_t is_set;
	char *param;
};

typedef struct clo_str clo_t;

void usage(clo_t[]);
int parse_clo(clo_t *, int, char **, int *, char **);
boolean_t clo_is_set(clo_t *, char);
char *clo_param(clo_t *, char);

#endif
