/*

 Dataset creation functions

 by Nuno D. Mendes
 $Id: dataset.c,v 1.1 2008/10/02 16:32:52 rnl14480 Exp $

 */

#include <stdlib.h>
#include <stdio.h>
#include "sequences.h"
#include "util.h"
#include "types.h"

dataset_t *creat_dataset(ushort seqn, char **sequences, char **headers) {
	dataset_t *ds = NULL;

	ds = (dataset_t *) safe_malloc(sizeof(dataset_t));
	ds->seqn = seqn;
	ds->sequences = sequences;
	ds->headers = headers;

	return ds;
}

void destroy_dataset(dataset_t * ds) {
	int i = 0;

	if (ds == NULL)
		return;

	for (i = 0; i < ds->seqn; i++) {
		if (ds->sequences[i] != NULL)
			safe_free(ds->sequences[i]);
		if (ds->headers[i] != NULL)
			safe_free(ds->headers[i]);
	}

	safe_free(ds->sequences);
	safe_free(ds->headers);
	safe_free(ds);

	return;
}
