/*

 Functions to manipulate hits

 by Nuno D. Mendes
 $Id: hit.c,v 1.4 2009/06/13 17:55:19 rnl14480 Exp $
 */

#include <stdlib.h>
#include "hit.h"
#include "lalign.h"
#include "util.h"
#include "debug.h"

hit_t *creat_hit(align_t *align, uint window, unsigned long offset,
		uint sequence, strand_t strand) {
	hit_t *hit = NULL;

	hit = (hit_t *) safe_malloc(sizeof(hit_t));

	hit->align = align;
	hit->window = window;
	hit->offset = offset;
	hit->sequence = sequence;
	hit->strand = strand;

	return hit;
}

int hit_score(hit_t *hit) {
	if (hit == NULL)
		return 0;
	return align_score(hit->align);
}

float hit_hitscore(hit_t *hit) {
	int slen = 0;
	if (hit == NULL)
		return 0.0;
	slen = hit->align->max_i + hit->align->max_j;
	if (slen > 0)
		return (2.0 * hit->align->score) / (hit->align->max_i
				+ hit->align->max_j);
	else
		return 0.0;
}

void destroy_hit(hit_t *hit) {
	if (hit == NULL)
		return;

	destroy_align(hit->align);
	safe_free(hit);
}

