/*

 List of hits

 by Nuno D. Mendes	
 $Id: hlist.c,v 1.3 2009/06/13 17:55:19 rnl14480 Exp $


 */

#include <stdlib.h>
#include <stdio.h>

#include "list.h"
#include "hlist.h"
#include "util.h"
#include "hit.h"

hlist_t *creat_hlist() {
	hlist_t *list = NULL;
	list = creat_list((int(*)(void *, void *)) hit_compare, (int(*)(void *,
			void *)) hit_equal, (unsigned int(*)(void *)) hit_id);

	return list;
}

hlist_t *hlist_clone(hlist_t * l) {
	hlist_t *nl = NULL;
	hiterator_t *i = NULL;

	nl = creat_hlist();
	i = hlist_iterate_reset(l);
	while (hlist_iterate_has_next(i))
		hlist_add_hit(nl, hlist_iterate_next(i));
	hlist_iterate_finish(i);

	return nl;
}

hit_t *hlist_get_first(hlist_t * l) {
	if (l == NULL)
		return NULL;
	return (hit_t *) list_get_first(l);
}

hit_t *hlist_get(hlist_t * l, uint id) {
	if (l == NULL)
		return NULL;
	return (hit_t *) list_get(l, id);
}

void hlist_destroy(hlist_t * l) {
	list_destroy(l);
}

hlist_t *hlist_add_hit(hlist_t * list, hit_t *l) {

	if (list == NULL)
		return list;
	list = list_add_elem_t(list, (void *) l);
	return list;

}

hlist_t *hlist_remove_hit(hlist_t * list, hit_t *l) {

	if (list == NULL)
		return list;
	list = list_remove_elem(list, (void *) l);
	return list;

}

int hlist_nhits(hlist_t * list) {
	if (list == NULL)
		return 0;
	return list_nelems(list);
}

hiterator_t *hlist_iterate_reset(hlist_t * l) {
	return list_iterate_reset(l);
}

hiterator_t *hlist_iterate_rewind(hlist_t * l) {
	return list_iterate_rewind(l);
}

int hlist_iterate_has_next(hiterator_t * i) {
	return list_iterate_has_next(i);
}

int hlist_iterate_has_previous(hiterator_t * i) {
	return list_iterate_has_previous(i);
}

hit_t *hlist_iterate_next(hiterator_t * i) {
	return (hit_t *) list_iterate_next(i);
}

hit_t *hlist_iterate_previous(hiterator_t * i) {
	return (hit_t *) list_iterate_previous(i);
}

void hlist_iterate_finish(hiterator_t * i) {
	list_iterate_finish(i);
}

int hit_compare(hit_t *h1, hit_t *h2) {
	if (h1->offset < h2->offset)
		return -1;
	else if (h1->offset > h2->offset)
		return 1;
	else
		return 0;
}

int hit_equal(hit_t *h1, hit_t *h2) {
	if (h1 == NULL || h2 == NULL)
		return 0;

	return (h1->offset == h2->offset);
}

int hit_id(hit_t *h) {
	if (h == NULL)
		return 0;
	return h->offset;
}
