/*

 Headers for hlist.c

 by Nuno D. Mendes
 $Id: hlist.h,v 1.3 2009/06/09 16:10:35 rnl14480 Exp $


 */

#ifndef LLIST_H
#define LLIST_H

#include "list.h"
#include "types.h"
#include "hit.h"

typedef list_t hlist_t;
typedef iterator_t hiterator_t;

hlist_t *creat_hlist();
hlist_t *hlist_clone(hlist_t *);
void hlist_destroy(hlist_t *);
hlist_t *hlist_add_hit(hlist_t *, hit_t *);
hit_t *hlist_get_first(hlist_t *);
hit_t *hlist_get_last(hlist_t *);
hit_t *hlist_get(hlist_t *, uint);
hlist_t *hlist_remove_hit(hlist_t *, hit_t *);
int hlist_nhits(hlist_t *);

hiterator_t *hlist_iterate_reset(hlist_t *);
hiterator_t *hlist_iterate_rewind(hlist_t *);
int hlist_iterate_has_next(hiterator_t *);
int hlist_iterate_has_previous(hiterator_t *);
hit_t *hlist_iterate_next(hiterator_t *);
hit_t *hlist_iterate_previous(hiterator_t *);
void hlist_iterate_finish(hiterator_t *);

int hit_compare(hit_t *, hit_t *);
int hit_equal(hit_t *, hit_t *);
int hit_id(hit_t *);

#endif
