/*

 Header for lalign.c

 by Nuno D. Mendes
 $Id: lalign.h,v 1.5 2009/06/09 16:10:35 rnl14480 Exp $


 */

#ifndef LALIGN_H
#define LALIGN_H

#include "types.h"

typedef enum dir_en {
	D_ANY, D_MATCH, D_MISMATCH, D_UP, D_LEFT
} dir_t;
typedef unsigned int index_t;

typedef struct align_str {
	index_t i;
	index_t j;
	index_t max_i;
	index_t max_j;
	dir_t *align_string;
	unsigned int mlen; /* match length */
	int score;
} align_t;

typedef struct model_str {
	float gap; /* gap penalty */
	float **score_matrix;
} model_t;

model_t *creat_model(float, float, float, strand_t);
void print_alignment(char *, int, align_t *);
align_t *compute_match(char *, int, model_t *);
align_t *align_clone(align_t *);
int align_score(align_t *);

void destroy_model(model_t *);
void destroy_align(align_t *);

#endif
